#include "omp_testsuite.h"


    int tids[NUM_TASKS];
    int includedtids[NUM_TASKS];
    int i;
    

/* Declaration of the functions containing the code for the orphan regions */
#include <stdio.h>


/* End of declaration */


#include <stdio.h>
#include <math.h>
#include "omp_testsuite.h"
#include "omp_my_sleep.h"


int orph_test_omp_task_final(FILE * logFile){
    
    int error;
#pragma omp parallel 
{
#pragma omp single
    {
        for (i = 0; i < NUM_TASKS; i++) {
            
            /* First we have to store the value of the loop index in a new variable
             * which will be private for each task because otherwise it will be overwritten
             * if the execution of the task takes longer than the time which is needed to 
             * enter the next step of the loop!
             */
            int myi;
            myi = i;

            #pragma omp task final(i>=10)
            {
                tids[myi] = omp_get_thread_num();
                /*we generate included tasks for final tasks*/
                if(myi >= 10){
                    int included = myi;
                    #pragma omp task
                    {
                        my_sleep (SLEEPTIME);

                        includedtids[included] = omp_get_thread_num();
                    } /* end of omp included task of the final task */

                    my_sleep (SLEEPTIME);

                } /* end of if it is a final task*/

            } /* end of omp task */
            
        } /* end of for */
    } /* end of single */
} /*end of parallel */

/* Now we check if more than one thread executed the final task and its included task. */
    for (i = 10; i < NUM_TASKS; i++) {
        if (tids[i] != includedtids[i])
            error++;
    }
    return (error==0);
} /* end of check_paralel_for_private */
int main()
{
	int i;			/* Loop index */
	int result;		/* return value of the program */
	int failed=0; 		/* Number of failed tests */
	int success=0;		/* number of succeeded tests */
	static FILE * logFile;	/* pointer onto the logfile */
	static const char * logFileName = "bin/c/orph_test_omp_task_final.log";	/* name of the logfile */


	/* Open a new Logfile or overwrite the existing one. */
	logFile = fopen(logFileName,"w+");

	printf("######## OpenMP Validation Suite V %s ######\n", OMPTS_VERSION );
	printf("## Repetitions: %3d                       ####\n",REPETITIONS);
	printf("## Loop Count : %6d                    ####\n",LOOPCOUNT);
	printf("##############################################\n");
	printf("Testing omp task final\n\n");

	fprintf(logFile,"######## OpenMP Validation Suite V %s ######\n", OMPTS_VERSION );
	fprintf(logFile,"## Repetitions: %3d                       ####\n",REPETITIONS);
	fprintf(logFile,"## Loop Count : %6d                    ####\n",LOOPCOUNT);
	fprintf(logFile,"##############################################\n");
	fprintf(logFile,"Testing omp task final\n\n");

	for ( i = 0; i < REPETITIONS; i++ ) {
		fprintf (logFile, "\n\n%d. run of orph_test_omp_task_final out of %d\n\n",i+1,REPETITIONS);
		if(orph_test_omp_task_final(logFile)){
			fprintf(logFile,"Test successful.\n");
			success++;
		}
		else {
			fprintf(logFile,"Error: Test failed.\n");
			printf("Error: Test failed.\n");
			failed++;
		}
	}

    if(failed==0){
		fprintf(logFile,"\nDirective worked without errors.\n");
		printf("Directive worked without errors.\n");
		result=0;
	}
	else{
		fprintf(logFile,"\nDirective failed the test %i times out of %i. %i were successful\n",failed,REPETITIONS,success);
		printf("Directive failed the test %i times out of %i.\n%i test(s) were successful\n",failed,REPETITIONS,success);
		result = (int) (((double) failed / (double) REPETITIONS ) * 100 );
	}
	printf ("Result: %i\n", result);
	return result;
}

/* Automatically generated definitions of the orphan functions */

void orph1_omp_task_final (FILE * logFile) {
            /* First we have to store the value of the loop index in a new variable
             * which will be private for each task because otherwise it will be overwritten
             * if the execution of the task takes longer than the time which is needed to 
             * enter the next step of the loop!
             */
            int myi;
            myi = i;

            #pragma omp task final(i>=10)
            {
                tids[myi] = omp_get_thread_num();
                /*we generate included tasks for final tasks*/
                if(myi >= 10){
                    int included = myi;
                    #pragma omp task
                    {
                        my_sleep (SLEEPTIME);

                        includedtids[included] = omp_get_thread_num();
                    } /* end of omp included task of the final task */

                    my_sleep (SLEEPTIME);

                } /* end of if it is a final task*/

            } /* end of omp task */
            
}
/* End of automatically generated definitions */
