
  ! TODO:
  ! C. Niethammer:
  !       Find check to decide if the test was run as schedule(static) because
  !       this also can pass the test if the work is devided into thread-counts 
      INTEGER FUNCTION test_do_schedule_guided()
        IMPLICIT NONE
        INTEGER omp_get_thread_num,omp_get_num_threads
        CHARACTER*20 logfile
        INTEGER threads
        INTEGER tmp_count
        INTEGER, allocatable :: tmp(:)
        INTEGER ii, flag
        INTEGER result
        INTEGER expected
        INTEGER openwork
        DOUBLE PRECISION c

                
        INTEGER i
        INTEGER tid
        INTEGER count

        INTEGER DELAY 
        INTEGER MAX_TIME
        INTEGER CFSMAX_SIZE

! ... choose small iteration space for small sync. overhead
        PARAMETER (DELAY = 1)
        PARAMETER (MAX_TIME = 5)
        PARAMETER (CFSMAX_SIZE = 150)

        INTEGER notout
        INTEGER maxiter
        INTEGER tids(0:CFSMAX_SIZE-1)

        COMMON /orphvars/ notout,maxiter,tids
                

        result = 0
        notout = 1
        maxiter = 0
        count = 0
        tmp_count = 0
        openwork = CFSMAX_SIZE


      test_do_schedule_guided = 0
      END

!This is the main driver to invoke different test functions
      PROGRAM test_do_schedule_guided_main
      IMPLICIT NONE
      INTEGER failed, success !Number of failed/succeeded tests
      INTEGER num_tests,crosschecked, crossfailed, j
      INTEGER temp,temp1
      INCLUDE "omp_testsuite.f"

      INTEGER test_do_schedule_guided


      CHARACTER*50 logfilename !Pointer to logfile
      INTEGER result 

      num_tests = 0
      crosschecked = 0
      crossfailed = 0
      result = 1
      failed = 0

      !Open a new logfile or overwrite the existing one.
      logfilename = "bin/fortran/test_do_schedule_guided.log"
!      WRITE (*,*) "Enter logFilename:" 
!      READ  (*,*) logfilename

      OPEN (1, FILE = logfilename)
 
      WRITE (*,*) "######## OpenMP Validation Suite V 3.0a ######"
      WRITE (*,*) "## Repetitions:", N 
      WRITE (*,*) "## Loop Count :", LOOPCOUNT
      WRITE (*,*) "##############################################"
      WRITE (*,*)

      crossfailed=0
      result=1
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) "Testing omp do schedule(guided)"
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) 
      WRITE (1,*) "testname: test_do_schedule_guided"
      WRITE (1,*) "(Crosstests should fail)"
      WRITE (1,*)
      
      DO j = 1, N
        temp =  test_do_schedule_guided()
        IF (temp .EQ. 1) THEN
          WRITE (1,*)  j, ". test successfull."
          success = success + 1
        ELSE
          WRITE (1,*) "Error: ",j, ". test failed."
          failed = failed + 1
        ENDIF
      END DO

      
      IF (failed .EQ. 0) THEN
        WRITE (1,*) "Directive worked without errors."
        WRITE (*,*) "Directive worked without errors."
        result = 0
        WRITE (*,*) "Result:",result
      ELSE
        WRITE (1,*) "Directive failed the test ", failed, " times."
        WRITE (*,*) "Directive failed the test ", failed, " times."
        result = failed * 100 / N
        WRITE (*,*) "Result:",result
      ENDIF
      CALL EXIT (result)
      END PROGRAM 

! Definitions of the orphan functions

      SUBROUTINE orph1__do_schedule_guided()
      INCLUDE "omp_testsuite.f"

        INTEGER i
        INTEGER tid
        INTEGER count

        INTEGER DELAY 
        INTEGER MAX_TIME
        INTEGER CFSMAX_SIZE

! ... choose small iteration space for small sync. overhead
        PARAMETER (DELAY = 1)
        PARAMETER (MAX_TIME = 5)
        PARAMETER (CFSMAX_SIZE = 150)

        INTEGER notout
        INTEGER maxiter
        INTEGER tids(0:CFSMAX_SIZE-1)

        COMMON /orphvars/ notout,maxiter,tids
                

!$omp do schedule(guided)
        DO i = 0 , CFSMAX_SIZE-1
          count = 0
!$omp flush(maxiter)
          IF ( i .GT. maxiter ) THEN                 
!$omp critical
            maxiter = i
!$omp end critical
          END IF

!..         if it is not our turn we wait
!           a) until another thread executed an iteration
!           with a higher iteration count
!           b) we are at the end of the loop (first thread finished
!             and set notout=0 OR
!           c) timeout arrived 

!$omp flush(maxiter,notout)
          IF ( notout .GE. 1 .AND. count .LT. MAX_TIME
     &         .AND. maxiter .EQ. i ) THEN
              DO WHILE ( notout .GE. 1 .AND. count .LT. MAX_TIME
     &          .AND. maxiter .EQ. i )
                CALL sleep(DELAY)
                count = count + DELAY
              END DO         
          END IF
           tids(i) = tid
        END DO
!$omp end do nowait
        
      END SUBROUTINE
! End of definition

