
      INTEGER FUNCTION test_omp_testlock()
        IMPLICIT NONE
        INTEGER result
        INTEGER nr_threads_in_single
        INTEGER nr_iterations
        INTEGER i
              
        include "omp_lib.h"
        INTEGER (KIND=OMP_LOCK_KIND)::lock
        COMMON /orphvars/ lock
              
        INCLUDE "omp_testsuite.f"

        nr_iterations=0
        nr_threads_in_single=0
        CALL OMP_INIT_LOCK(lock)
        result=0

!$omp parallel shared(lock,nr_threads_in_single,nr_iterations,result)
!$omp do
        DO i=1,LOOPCOUNT
                        CALL orph1__omp_testlock();
!$omp flush
          nr_threads_in_single=nr_threads_in_single+1
!$omp flush
          nr_iterations=nr_iterations+1
          nr_threads_in_single=nr_threads_in_single-1
          result=result+nr_threads_in_single
                        CALL orph2__omp_testlock();
        END DO
!$omp end do
!$omp end parallel
        CALL OMP_DESTROY_LOCK(lock)
!               print *, result, nr_iterations
        IF(result.EQ.0 .AND. nr_iterations .EQ. LOOPCOUNT) THEN
          test_omp_testlock=1
        ELSE
          test_omp_testlock=0
        ENDIF
      END FUNCTION
!This is the main driver to invoke different test functions
      PROGRAM test_omp_testlock_main
      IMPLICIT NONE
      INTEGER failed, success !Number of failed/succeeded tests
      INTEGER num_tests,crosschecked, crossfailed, j
      INTEGER temp,temp1
      INCLUDE "omp_testsuite.f"

      INTEGER test_omp_testlock


      CHARACTER*50 logfilename !Pointer to logfile
      INTEGER result 

      num_tests = 0
      crosschecked = 0
      crossfailed = 0
      result = 1
      failed = 0

      !Open a new logfile or overwrite the existing one.
      logfilename = "bin/fortran/test_omp_testlock.log"
!      WRITE (*,*) "Enter logFilename:" 
!      READ  (*,*) logfilename

      OPEN (1, FILE = logfilename)
 
      WRITE (*,*) "######## OpenMP Validation Suite V 3.0a ######"
      WRITE (*,*) "## Repetitions:", N 
      WRITE (*,*) "## Loop Count :", LOOPCOUNT
      WRITE (*,*) "##############################################"
      WRITE (*,*)

      crossfailed=0
      result=1
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) "Testing omp_test_lock"
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) 
      WRITE (1,*) "testname: test_omp_testlock"
      WRITE (1,*) "(Crosstests should fail)"
      WRITE (1,*)
      
      DO j = 1, N
        temp =  test_omp_testlock()
        IF (temp .EQ. 1) THEN
          WRITE (1,*)  j, ". test successfull."
          success = success + 1
        ELSE
          WRITE (1,*) "Error: ",j, ". test failed."
          failed = failed + 1
        ENDIF
      END DO

      
      IF (failed .EQ. 0) THEN
        WRITE (1,*) "Directive worked without errors."
        WRITE (*,*) "Directive worked without errors."
        result = 0
        WRITE (*,*) "Result:",result
      ELSE
        WRITE (1,*) "Directive failed the test ", failed, " times."
        WRITE (*,*) "Directive failed the test ", failed, " times."
        result = failed * 100 / N
        WRITE (*,*) "Result:",result
      ENDIF
      CALL EXIT (result)
      END PROGRAM 

! Definitions of the orphan functions

      SUBROUTINE orph1__omp_testlock()
      INCLUDE "omp_testsuite.f"

        include "omp_lib.h"
        INTEGER (KIND=OMP_LOCK_KIND)::lock
        COMMON /orphvars/ lock
              

                  
          DO WHILE (.NOT. OMP_TEST_LOCK(lock))
          END DO
                  
                  
      END SUBROUTINE
! End of definition


      SUBROUTINE orph2__omp_testlock()
      INCLUDE "omp_testsuite.f"

        include "omp_lib.h"
        INTEGER (KIND=OMP_LOCK_KIND)::lock
        COMMON /orphvars/ lock
              

                  
          CALL OMP_UNSET_LOCK(lock)
                  
                  
      END SUBROUTINE
! End of definition

