
      INCLUDE "omp_my_sleep.f"

      INTEGER FUNCTION test_omp_task_if()
        IMPLICIT NONE
        INCLUDE "omp_testsuite.f"
        
        external my_sleep
        INTEGER dummy
        LOGICAL condition_false
        INTEGER cnt
        INTEGER rslt
        COMMON /orphvars/ condition_false, cnt, rslt
        

        cnt = 0
        condition_false = (dummy .eq. 314159)

!$omp parallel
!$omp single
        
!$omp task if (condition_false) shared(cnt,rslt)
          call my_sleep(SLEEPTIME_LONG)
!$omp flush
          if (cnt .eq. 0) then
              rslt = 1
          else
              rslt = 0
          end if
!$omp end task
        
        cnt = 1
!$omp end single
!$omp end parallel

        test_omp_task_if = rslt

      END FUNCTION
!This is the main driver to invoke different test functions
      PROGRAM test_omp_task_if_main
      IMPLICIT NONE
      INTEGER failed, success !Number of failed/succeeded tests
      INTEGER num_tests,crosschecked, crossfailed, j
      INTEGER temp,temp1
      INCLUDE "omp_testsuite.f"

      INTEGER test_omp_task_if


      CHARACTER*50 logfilename !Pointer to logfile
      INTEGER result 

      num_tests = 0
      crosschecked = 0
      crossfailed = 0
      result = 1
      failed = 0

      !Open a new logfile or overwrite the existing one.
      logfilename = "bin/fortran/test_omp_task_if.log"
!      WRITE (*,*) "Enter logFilename:" 
!      READ  (*,*) logfilename

      OPEN (1, FILE = logfilename)
 
      WRITE (*,*) "######## OpenMP Validation Suite V 3.0a ######"
      WRITE (*,*) "## Repetitions:", N 
      WRITE (*,*) "## Loop Count :", LOOPCOUNT
      WRITE (*,*) "##############################################"
      WRITE (*,*)

      crossfailed=0
      result=1
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) "Testing omp task if"
      WRITE (1,*) "--------------------------------------------------"
      WRITE (1,*) 
      WRITE (1,*) "testname: test_omp_task_if"
      WRITE (1,*) "(Crosstests should fail)"
      WRITE (1,*)
      
      DO j = 1, N
        temp =  test_omp_task_if()
        IF (temp .EQ. 1) THEN
          WRITE (1,*)  j, ". test successfull."
          success = success + 1
        ELSE
          WRITE (1,*) "Error: ",j, ". test failed."
          failed = failed + 1
        ENDIF
      END DO

      
      IF (failed .EQ. 0) THEN
        WRITE (1,*) "Directive worked without errors."
        WRITE (*,*) "Directive worked without errors."
        result = 0
        WRITE (*,*) "Result:",result
      ELSE
        WRITE (1,*) "Directive failed the test ", failed, " times."
        WRITE (*,*) "Directive failed the test ", failed, " times."
        result = failed * 100 / N
        WRITE (*,*) "Result:",result
      ENDIF
      CALL EXIT (result)
      END PROGRAM 
